/*
 * This file is a part of morm
 * and is distributed under the 2-Clause BSD licence.
 * Author: Tomasz Sowa <t.sowa@ttmath.org>
 */

/*
 * Copyright (c) 2019, Tomasz Sowa
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

#ifndef headerfile_morm_samples_person
#define headerfile_morm_samples_person

#include <string>
#include "morm.h"
#include "language.h"
#include "attachment.h"



namespace morm
{
namespace samples
{

/*
CREATE TABLE public.person (
    id bigserial,
    first_name varchar(64),
    last_name varchar(64),
    email varchar(64),
    language_id bigint,

    primary key(id)
);
*/

class Person : public morm::Model
{
public:

	long id;
	std::wstring first_name;
	std::wstring last_name;
	std::wstring email;
	Language language;

	Attachment attachment;

	void map_fields()
	{
		field(L"id", id, false, false, true);
		//field(L"id", id, f::no_insertable | f::no_updatable | f::primary_key);

		field(L"first_name", first_name);
		field(L"last_name", last_name);
		field(L"email", email);
		field(L"language_id", language);

		field(L"person_id", attachment, true, true, false);
		//field(L"person_id", attachment, f::insertable | f::updatable | f::foreign_key);
		//field(L"person_id", attachment, f::insertable, f::updatable, f::foreign_key);
	}

	void table_name(PT::TextStream & stream)
	{
		// schema.table_name or just table_name
		stream << "public.person";
	}

	void after_insert()
	{
		get_last_sequence(L"public.person_id_seq", id);
	}


};



}
}


#endif

