/*
 * This file is a part of morm
 * and is distributed under the 2-Clause BSD licence.
 * Author: Tomasz Sowa <t.sowa@ttmath.org>
 */

/*
 * Copyright (c) 2019, Tomasz Sowa
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

#include <ctime>
#include "basesample.h"
#include "person.h"
#include "language.h"
#include "attachment.h"


namespace morm
{
namespace samples
{

class Sample01 : public BaseSample
{
public:


void make()
{
	person.set_connector(model_connector);
	load_defaults(person);

	std::wstring sss = L"cosik";
	person.set_field_value_generic(L"email", L"email", sss);

	person.insert();
}



private:

	Person person;



	static void load_defaults(Person & person)
	{
		person.id = 200;
		person.first_name = L"MyFirstName";
		person.last_name = L"MyLastName";
		person.email = L"myemail@mydomain.ltd";

		person.language.id = 100;
		person.language.english_name = L"english";
		person.language.local_name = L"polish";
		person.language.code_str = L"en";
		person.language.code_int = 200;

		std::time_t t = std::time(0);

		person.attachment.person_id = -1;
		person.attachment.created_date.FromTime(t);
		person.attachment.name = L"attchment name";
		person.attachment.content = "long binary content";
		person.attachment.some_flags = true;
	}



};


}
}

